-- Object-Oriented Menu function by MikuAuahDark

local Menu={}
Menu.list={}

New=New or function(t,...)
	return t.New(...)
end

function Menu.New(title,_sel)
	local temp={}
	local id=0
	table.insert(Menu.list,temp)
	for n,v in pairs(Menu.list) do
		if v==temp then
			id=n
			break
		end
	end
	temp.title=title
	temp.selstr={}
	temp.selfunc={}
	function temp:Show(_id)
		local t=self.title..string.rep(" ",id)
		for i=1,9 do
			t=t..","..(self.selstr[i] or "")
		end
		menu(_id,t)
	end
	function temp:SetSel(sel,str,func)
		if str~=nil then
			self.selstr[sel]=str
		end
		if type(func)=="function" then
			self.selfunc[sel]=func
		end
	end
	function temp:SetTitle(lpcstr)
		temp.title=lpcstr
	end
	setmetatable(temp,{
		__unm=function(self)
			return self.title
		end,
		__call=function(self,_id)
			self:Show(id)
		end,
		__tostring=function()
			return "Menu ("..id..")"
		end,
	})
	for n,v in pairs(_sel) do
		temp:SetSel(n,v[1],v[2])
	end
	return temp
end

addhook("menu","Menu.Callback")
function Menu.Callback(id,men,sel)
	for n,v in pairs(Menu.list) do
		if ((-v)..string.rep(" ",n))==men then
			pcall(v.selfunc[sel],id,men,sel)
			break
		end
	end
end

setmetatable(Menu,{
	__metatable=function(_)
		return tostring(_)
	end,
	__newindex=function(_)
		error("Access denied!",2)
	end
})

return Menu